package blatt10;

/**
 * Diese Klasse ist zum Testen des Programmes. Diese Klasse darf nicht
 * veraendert werden.
 */
public class Main {

	/**
	 * Die Main-Methode erstellt eine neue Routing-Tabelle und fuehrt
	 * anschliessend einige testaufrufe aus.
	 * 
	 * @param args
	 */
	public static void main(String[] args) {

		// Eigene IP-Adresse 212.84.12.1
		Router myRouter = new Router(IP(212, 84, 12, 1));
		// 212.84.12.0 ; 0.0.0.0 ; 255.255.255.0 ; U ; eth0
		myRouter.routeAdd(IP(212, 84, 12, 0), IP(0, 0, 0, 0),
				IP(255, 255, 255, 0), new Flags[] { Flags.U }, "eth0");
		// 212.84.12.128 ; 212.84.12.2 ; 255.255.255.128 ; UG ; eth0
		myRouter.routeAdd(IP(212, 84, 12, 128), IP(212, 84, 12, 2),
				IP(255, 255, 255, 128), new Flags[] { Flags.U, Flags.G },
				"eth0");
		// Find Route for 13.37.23.42
		System.out.println("Searching for route: 13.37.23.42\nInterface: "
				+ myRouter.findRoute(IP(13,37,23,42)));
		// 13.37.23.41 ; 0.0.0.0 ; 255.255.255.255 ; UH ; eth1
		myRouter.routeAdd(IP(13, 37, 23, 41), IP(0, 0, 0, 0),
				IP(255, 255, 255, 255), new Flags[] { Flags.U, Flags.H },
				"eth1");
		// loesche 13.37.23.42
		myRouter.routeDelete(IP(13, 37, 23, 41));
		// 13.37.23.42 ; 0.0.0.0 ; 255.255.255.255 ; UH ; eth1
		myRouter.routeAdd(IP(13, 37, 23, 42), IP(0, 0, 0, 0),
				IP(255, 255, 255, 255), new Flags[] { Flags.U, Flags.H },
				"eth1");
		// 221.2.0.0 ; 221.2.0.1 ; 225.255.0.0 ; UG ; eth2
		myRouter.routeAdd(IP(221, 2, 0, 0), IP(221, 2, 0, 1),
				IP(255, 255, 0, 0), new Flags[] { Flags.U, Flags.G }, "eth2");
		// 0.0.0.0 ; 212.69.12.12 ; 0.0.0.0 ; UG ; eth0
		myRouter.routeAdd(IP(0, 0, 0, 0), IP(212, 69, 12, 12), IP(0, 0, 0, 0),
				new Flags[] { Flags.U, Flags.G }, "eth0");
		// 212.84.12.128 ; 212.84.12.3 ; 255.255.255.128 ; UG ; eth0
		myRouter.routeModify(IP(212, 84, 12, 128), IP(212, 84, 12, 3),
				IP(255, 255, 255, 128), new Flags[] { Flags.U, Flags.G },
				"eth3");
		// Find Route for 212.84.12.144
		System.out.println("Searching for route: 212.84.12.144\nInterface: "
				+ myRouter.findRoute(IP(212, 84, 12, 144)));		
		// Find Route for 212.84.12.44
		System.out.println("Searching for route: 212.84.12.44\nInterface: " + myRouter.findRoute(IP(212, 84, 12, 44)));
		// Set local IP to 212.84.12.7
		myRouter.setLocalIP(IP(212, 84, 12, 7));
		// 112.84.12.0 ; 0.0.0.0 ; 255.255.255.15 ; U ; eth0
		myRouter.routeAdd(IP(112, 84, 12, 0), IP(0, 0, 0, 0),
				IP(255, 255, 255, 15), new Flags[] { Flags.U }, "eth0");
		// Find Route for 212.84.12.7
		System.out.println("Searching for route: 212.84.12.7\nInterface: "
				+ myRouter.findRoute(IP(212, 84, 12, 7)));		
		// Print Table
		myRouter.printTable();
		myRouter.routeModify(IP(212, 84, 12, 128), IP(212, 84, 12, 2),
				IP(255, 255, 255, 128), new Flags[] {Flags.G },
				"eth0");		
		// Find Route for 212.84.12.144
		System.out.println("Searching for route: 212.84.12.144\nInterface: "
				+ myRouter.findRoute(IP(212, 84, 12, 144)));
		// Find Route for 13.37.23.42
		System.out.println("Searching for route: 13.37.23.42\nInterface: "
				+ myRouter.findRoute(IP(13,37,23,42)));
		// Print Table
		myRouter.printTable();
	}

	/**
	 * Hilfsmethode um IP-Adressen in Integers umzuwandeln. Nicht benutzen.
	 */
	private static int IP(int a, int b, int c, int d) {
		return ((a & 0xFF) << 24) | ((b & 0xFF) << 16) | ((c & 0xFF) << 8)
				| (d & 0xFF);
	}
}
